#include <map>
#include <stdexcept>
#include "keys.h"

using namespace std;

namespace Msp {
namespace Input {

extern unsigned sys_keymap[];

unsigned key_from_sys(unsigned code)
{
	static bool init_done = false;
	static map<unsigned, unsigned> reverse_map;

	if(!init_done)
	{
		for(unsigned i=0; i<N_KEYS_; ++i)
			if(sys_keymap[i])
				reverse_map[sys_keymap[i]] = i;

		init_done = true;
	}

	map<unsigned, unsigned>::const_iterator i = reverse_map.find(code);
	if(i!=reverse_map.end())
		return i->second;

	return 0;
}

unsigned key_to_sys(unsigned key)
{
	if(key>=N_KEYS_)
		throw invalid_argument("key_to_sys");
	return sys_keymap[key];
}

} // namespace Input
} // namespace Msp
